<html><head><meta name="color-scheme" content="light dark"></head><body><pre style="word-wrap: break-word; white-space: pre-wrap;">diff --git a/pom.xml b/pom.xml
index 5e26137..c14c21b 100644
--- a/pom.xml
+++ b/pom.xml
@@ -6,12 +6,12 @@
     &lt;groupId&gt;org.jenkins-ci.plugins&lt;/groupId&gt;
     &lt;artifactId&gt;plugin&lt;/artifactId&gt;
     &lt;!-- See https://github.com/jenkinsci/plugin-pom/blob/master/CHANGELOG.md --&gt;
-    &lt;version&gt;4.47&lt;/version&gt;
+    &lt;version&gt;4.71&lt;/version&gt;
     &lt;relativePath /&gt;
   &lt;/parent&gt;
 
   &lt;artifactId&gt;sonar&lt;/artifactId&gt;
-  &lt;version&gt;2.15&lt;/version&gt;
+  &lt;version&gt;2.15.1&lt;/version&gt;
   &lt;packaging&gt;hpi&lt;/packaging&gt;
 
   &lt;name&gt;SonarQube Scanner for Jenkins&lt;/name&gt;
@@ -45,7 +45,7 @@
   &lt;/ciManagement&gt;
 
   &lt;properties&gt;
-    &lt;revision&gt;2.15&lt;/revision&gt;
+    &lt;revision&gt;2.15.1&lt;/revision&gt;
     &lt;changelist&gt;-SNAPSHOT&lt;/changelist&gt;
     &lt;gitHubRepo&gt;jenkinsci/sonarqube-plugin&lt;/gitHubRepo&gt;
     &lt;project.build.sourceEncoding&gt;UTF-8&lt;/project.build.sourceEncoding&gt;
@@ -53,9 +53,8 @@
     &lt;sonar.exclusions&gt;target/generated-sources/**/*&lt;/sonar.exclusions&gt;
     &lt;gitRepositoryName&gt;sonar-scanner-jenkins&lt;/gitRepositoryName&gt;
     &lt;version.artifactory.plugin&gt;2.6.1&lt;/version.artifactory.plugin&gt;
-    &lt;jenkins.version&gt;2.361.1&lt;/jenkins.version&gt;
+    &lt;jenkins.version&gt;2.401.3&lt;/jenkins.version&gt;
     &lt;version.cyclonedx.plugin&gt;2.5.3&lt;/version.cyclonedx.plugin&gt;
-    &lt;java.level&gt;8&lt;/java.level&gt;
     &lt;findbugs.failOnError&gt;false&lt;/findbugs.failOnError&gt;
     &lt;!-- Disable parallel tests on Travis --&gt;
     &lt;concurrency&gt;1&lt;/concurrency&gt;
@@ -72,17 +71,15 @@
     &lt;license.mailto&gt;mailto:info AT sonarsource DOT com&lt;/license.mailto&gt;
 
     &lt;artifactsToPublish&gt;${project.groupId}:${project.artifactId}:hpi${project.groupId}:${project.artifactId}:json:cyclonedx&lt;/artifactsToPublish&gt;
-
-    &lt;maven.compiler.release&gt;8&lt;/maven.compiler.release&gt;
   &lt;/properties&gt;
 
   &lt;dependencyManagement&gt;
     &lt;dependencies&gt;
       &lt;!-- Resolve dependency conflicts of plugins used during tests (workflow) --&gt;
       &lt;dependency&gt;
-        &lt;groupId&gt;com.google.protobuf&lt;/groupId&gt;
-        &lt;artifactId&gt;protobuf-java&lt;/artifactId&gt;
-        &lt;version&gt;3.16.3&lt;/version&gt;
+          &lt;groupId&gt;org.jetbrains.kotlin&lt;/groupId&gt;
+          &lt;artifactId&gt;kotlin-stdlib-common&lt;/artifactId&gt;
+          &lt;version&gt;1.6.20&lt;/version&gt;
       &lt;/dependency&gt;
       &lt;dependency&gt;
         &lt;groupId&gt;com.jcraft&lt;/groupId&gt;
@@ -91,8 +88,8 @@
       &lt;/dependency&gt;
       &lt;dependency&gt;
         &lt;groupId&gt;io.jenkins.tools.bom&lt;/groupId&gt;
-        &lt;artifactId&gt;bom-2.361.x&lt;/artifactId&gt;
-        &lt;version&gt;1607.va_c1576527071&lt;/version&gt;
+        &lt;artifactId&gt;bom-2.401.x&lt;/artifactId&gt;
+        &lt;version&gt;2357.v1043f8578392&lt;/version&gt;
         &lt;scope&gt;import&lt;/scope&gt;
         &lt;type&gt;pom&lt;/type&gt;
       &lt;/dependency&gt;
@@ -161,7 +158,7 @@
     &lt;dependency&gt;
       &lt;groupId&gt;org.sonarsource.sonarqube&lt;/groupId&gt;
       &lt;artifactId&gt;sonar-ws&lt;/artifactId&gt;
-      &lt;version&gt;6.7&lt;/version&gt;
+      &lt;version&gt;10.1.0.73491&lt;/version&gt;
     &lt;/dependency&gt;
     &lt;dependency&gt;
       &lt;!-- needed for SonarPublisher --&gt;
diff --git a/src/test/java/hudson/plugins/sonar/client/HttpClientTest.java b/src/test/java/hudson/plugins/sonar/client/HttpClientTest.java
index 82cd6a3..16ff2d7 100644
--- a/src/test/java/hudson/plugins/sonar/client/HttpClientTest.java
+++ b/src/test/java/hudson/plugins/sonar/client/HttpClientTest.java
@@ -19,8 +19,21 @@
  */
 package hudson.plugins.sonar.client;
 
+import static org.assertj.core.api.Assertions.assertThat;
+import static org.assertj.core.api.Assertions.assertThatThrownBy;
+import static org.mockito.ArgumentMatchers.any;
+import static org.mockito.Mockito.mock;
+import static org.mockito.Mockito.verify;
+import static org.mockito.Mockito.when;
+
 import java.io.IOException;
 import java.nio.charset.StandardCharsets;
+
+import org.junit.Before;
+import org.junit.Test;
+import org.mockito.ArgumentCaptor;
+import org.sonarqube.ws.client.HttpException;
+
 import okhttp3.Call;
 import okhttp3.Credentials;
 import okhttp3.OkHttpClient;
@@ -29,17 +42,6 @@
 import okhttp3.Response;
 import okhttp3.ResponseBody;
 import okio.BufferedSource;
-import org.junit.Before;
-import org.junit.Test;
-import org.mockito.ArgumentCaptor;
-import org.sonarqube.ws.client.HttpException;
-
-import static org.assertj.core.api.Assertions.assertThat;
-import static org.assertj.core.api.Assertions.assertThatThrownBy;
-import static org.mockito.ArgumentMatchers.any;
-import static org.mockito.Mockito.mock;
-import static org.mockito.Mockito.verify;
-import static org.mockito.Mockito.when;
 
 public class HttpClientTest {
   private static final String URL = "http://sonarqube.org";
@@ -49,7 +51,7 @@
   BufferedSource source = mock(BufferedSource.class);
   HttpClient underTest = new HttpClient(okHttpClient);
   Request request = new Request.Builder().url(URL).build();
-  Response response = new Response.Builder().code(200).body(body).protocol(Protocol.HTTP_2).request(request).build();
+  Response response = new Response.Builder().code(200).body(body).protocol(Protocol.HTTP_2).request(request).message("foo").build();
 
   @Before
   public void setUp() throws IOException {
@@ -72,7 +74,7 @@
 
   @Test
   public void request_fail_should_throw_http_exception() throws IOException {
-    Response failedResponse = new Response.Builder().code(401).body(body).protocol(Protocol.HTTP_2).request(request).build();
+    Response failedResponse = new Response.Builder().code(401).body(body).protocol(Protocol.HTTP_2).request(request).message("foo").build();
     when(call.execute()).thenReturn(failedResponse);
 
     assertThatThrownBy(() -&gt; underTest.getHttp(URL, null))
</pre></body></html>